Index: binaries/data/mods/public/gui/credits/texts/programming.json
===================================================================
--- binaries/data/mods/public/gui/credits/texts/programming.json	(revisión: 18728)
+++ binaries/data/mods/public/gui/credits/texts/programming.json	(copia de trabajo)
@@ -96,6 +96,7 @@
 			{"nick": "Itms", "name": "Nicolas Auvray"},
 			{"nick": "Jaison", "name": "Marco tom Suden"},
 			{"nick": "jammus", "name": "James Scott"},
+                        {"nick": "javiergodas", "name": "Javier Godas Vieitez"},
 			{"nick": "Jgwman"},
 			{"nick": "JonBaer", "name": "Jon Baer"},
 			{"nick": "Josh", "name": "Joshua J. Bakita"},
Index: binaries/data/mods/public/gui/summary/summary.js
===================================================================
--- binaries/data/mods/public/gui/summary/summary.js	(revisión: 18728)
+++ binaries/data/mods/public/gui/summary/summary.js	(copia de trabajo)
@@ -91,8 +91,8 @@
 
 		let positionObject = playerBoxesCounts[playerState.team+1] - 1;
 		let rowPlayer = "playerBox[" + positionObject + "]";
+                let playerOutcome = "playerOutcome[" + positionObject + "]";
 		let playerNameColumn = "playerName[" + positionObject + "]";
-		let playerColorBoxColumn = "playerColorBox[" + positionObject + "]";
 		let playerCivicBoxColumn = "civIcon[" + positionObject + "]";
 		let playerCounterValue = "valueData[" + positionObject + "]";
 
@@ -99,8 +99,8 @@
 		if (playerState.team != -1)
 		{
 			rowPlayer = "playerBoxt[" + playerState.team + "][" + positionObject + "]";
+                        playerOutcome = "playerOutcomet[" + playerState.team + "][" + positionObject + "]";
 			playerNameColumn = "playerNamet[" + playerState.team + "][" + positionObject + "]";
-			playerColorBoxColumn = "playerColorBoxt[" + playerState.team + "][" + positionObject + "]";
 			playerCivicBoxColumn = "civIcont[" + playerState.team + "][" + positionObject + "]";
 			playerCounterValue = "valueDataTeam[" + playerState.team + "][" + positionObject + "]";
 		}
@@ -118,9 +118,6 @@
 		boxSize.right = rowPlayerObjectWidth;
 		rowPlayerObject.size = boxSize;
 
-		let playerColorBox = Engine.GetGUIObjectByName(playerColorBoxColumn);
-		playerColorBox.sprite = colorString + g_PlayerColorBoxAlpha;
-
 		Engine.GetGUIObjectByName(playerNameColumn).caption = g_GameData.sim.playerStates[i+1].name;
 
 		let civIcon = Engine.GetGUIObjectByName(playerCivicBoxColumn);
@@ -127,6 +124,18 @@
 		civIcon.sprite = "stretched:" + g_CivData[playerState.civ].Emblem;
 		civIcon.tooltip = g_CivData[playerState.civ].Name;
 
+                let outcome = Engine.GetGUIObjectByName(playerOutcome);
+                if(playerState.state == "won")
+                {
+                    outcome.sprite = "stretched:session/icons/stances/aggressive.png";
+                    outcome.tooltip = translate("Victory");
+                }
+                else if(playerState.state == "defeated")
+                {
+                    outcome.sprite = "stretched:session/icons/kill.png";
+                    outcome.tooltip = translate("Defeated");
+                }
+
 		updateCountersPlayer(playerState, panelInfo.counters, playerCounterValue);
 
 		calculateTeamCounters(playerState);
Index: binaries/data/mods/public/gui/summary/summary.xml
===================================================================
--- binaries/data/mods/public/gui/summary/summary.xml	(revisión: 18728)
+++ binaries/data/mods/public/gui/summary/summary.xml	(copia de trabajo)
@@ -119,9 +119,7 @@
 					<object size="0 30 100% 100%">
 						<repeat count="8" var="n">
 							<object type="image" name="playerBoxt[i][n]" size="10 0 10 30" hidden="true">
-								<object type="image" sprite="ForegroundBox" size="10 9 34 33">
-									<object name="playerColorBoxt[i][n]" type="image" size="2 2 22 22"/>
-								</object>
+                                                                <object name="playerOutcomet[i][n]" type="image" size="2 8 30 35"/>
 								<object name="playerNamet[i][n]" type="text" size="40 2 208 100%" style="ModernLeftLabelText"/>
 								<object name="civIcont[i][n]" type="image" size="208 5 240 37" />
 								<repeat var="x" count="8">
@@ -142,9 +140,7 @@
 			<object type="image" name="noTeamsBox" size="0 65 100% 100%-50" hidden="true">
 				<repeat count="8">
 					<object type="image" name="playerBox[n]" size="10 0 10 30" hidden="true">
-						<object type="image" sprite="ForegroundBox" size="10 9 34 33">
-							<object name="playerColorBox[n]" type="image" size="2 2 22 22"/>
-						</object>
+                                                <object name="playerOutcome[n]" type="image" size="2 8 30 35"/>
 						<object name="playerName[n]" type="text" size="40 2 208 100%" style="ModernLeftLabelText"/>
 						<object name="civIcon[n]" type="image" size="208 5 240 37"/>
 						<repeat var="x" count="8">