Index: binaries/data/mods/public/gui/credits/texts/programming.json
===================================================================
--- binaries/data/mods/public/gui/credits/texts/programming.json	(revisión: 18728)
+++ binaries/data/mods/public/gui/credits/texts/programming.json	(copia de trabajo)
@@ -96,6 +96,7 @@
 			{"nick": "Itms", "name": "Nicolas Auvray"},
 			{"nick": "Jaison", "name": "Marco tom Suden"},
 			{"nick": "jammus", "name": "James Scott"},
+                        {"nick": "javiergodas", "name": "Javier Godas Vieitez"},
 			{"nick": "Jgwman"},
 			{"nick": "JonBaer", "name": "Jon Baer"},
 			{"nick": "Josh", "name": "Joshua J. Bakita"},
Index: binaries/data/mods/public/gui/summary/summary.js
===================================================================
--- binaries/data/mods/public/gui/summary/summary.js	(revisión: 18728)
+++ binaries/data/mods/public/gui/summary/summary.js	(copia de trabajo)
@@ -91,6 +91,7 @@
 
 		let positionObject = playerBoxesCounts[playerState.team+1] - 1;
 		let rowPlayer = "playerBox[" + positionObject + "]";
+                let playerOutcome = "playerOutcome[" + positionObject + "]"; 
 		let playerNameColumn = "playerName[" + positionObject + "]";
 		let playerColorBoxColumn = "playerColorBox[" + positionObject + "]";
 		let playerCivicBoxColumn = "civIcon[" + positionObject + "]";
@@ -99,6 +100,7 @@
 		if (playerState.team != -1)
 		{
 			rowPlayer = "playerBoxt[" + playerState.team + "][" + positionObject + "]";
+                        playerOutcome = "playerOutcomet[" + playerState.team + "][" + positionObject + "]"; 
 			playerNameColumn = "playerNamet[" + playerState.team + "][" + positionObject + "]";
 			playerColorBoxColumn = "playerColorBoxt[" + playerState.team + "][" + positionObject + "]";
 			playerCivicBoxColumn = "civIcont[" + playerState.team + "][" + positionObject + "]";
@@ -121,6 +123,18 @@
 		let playerColorBox = Engine.GetGUIObjectByName(playerColorBoxColumn);
 		playerColorBox.sprite = colorString + g_PlayerColorBoxAlpha;
 
+		let outcome = Engine.GetGUIObjectByName(playerOutcome);
+		if (playerState.state == "won")
+		{
+			outcome.sprite = "stretched:session/icons/laurels.png";
+			outcome.tooltip = translate("Victory");
+		}
+		else if (playerState.state == "defeated")
+		{
+			outcome.sprite = "stretched:session/icons/kill.png";
+			outcome.tooltip = translate("Defeated");
+		}
+
 		Engine.GetGUIObjectByName(playerNameColumn).caption = g_GameData.sim.playerStates[i+1].name;
 
 		let civIcon = Engine.GetGUIObjectByName(playerCivicBoxColumn);
Index: binaries/data/mods/public/gui/summary/summary.xml
===================================================================
--- binaries/data/mods/public/gui/summary/summary.xml	(revisión: 18728)
+++ binaries/data/mods/public/gui/summary/summary.xml	(copia de trabajo)
@@ -119,10 +119,9 @@
 					<object size="0 30 100% 100%">
 						<repeat count="8" var="n">
 							<object type="image" name="playerBoxt[i][n]" size="10 0 10 30" hidden="true">
-								<object type="image" sprite="ForegroundBox" size="10 9 34 33">
-									<object name="playerColorBoxt[i][n]" type="image" size="2 2 22 22"/>
-								</object>
-								<object name="playerNamet[i][n]" type="text" size="40 2 208 100%" style="ModernLeftLabelText"/>
+							        <object name="playerColorBoxt[i][n]" type="image" size="2 2 40 40"/>
+                                                                <object name="playerOutcomet[i][n]" type="image" size="6 4 37 39"/>
+								<object name="playerNamet[i][n]" type="text" size="50 2 208 100%" style="ModernLeftLabelText"/>
 								<object name="civIcont[i][n]" type="image" size="208 5 240 37" />
 								<repeat var="x" count="8">
 									<object name="valueDataTeam[i][n][x]" type="text" style="ModernTabLabelText">
@@ -142,10 +141,9 @@
 			<object type="image" name="noTeamsBox" size="0 65 100% 100%-50" hidden="true">
 				<repeat count="8">
 					<object type="image" name="playerBox[n]" size="10 0 10 30" hidden="true">
-						<object type="image" sprite="ForegroundBox" size="10 9 34 33">
-							<object name="playerColorBox[n]" type="image" size="2 2 22 22"/>
-						</object>
-						<object name="playerName[n]" type="text" size="40 2 208 100%" style="ModernLeftLabelText"/>
+					        <object name="playerColorBox[n]" type="image" size="2 2 40 40"/>
+                                                <object name="playerOutcome[n]" type="image" size="6 4 37 39"/>
+						<object name="playerName[n]" type="text" size="50 2 208 100%" style="ModernLeftLabelText"/>
 						<object name="civIcon[n]" type="image" size="208 5 240 37"/>
 						<repeat var="x" count="8">
 							<object name="valueData[n][x]" type="text" style="ModernTabLabelText">