Index: binaries/data/mods/public/gui/credits/texts/programming.json
===================================================================
--- binaries/data/mods/public/gui/credits/texts/programming.json	(revision 18768)
+++ binaries/data/mods/public/gui/credits/texts/programming.json	(working copy)
@@ -94,10 +94,11 @@
 			{"nick": "infyquest", "name": "Vijay Kiran Kamuju"},
 			{"nick": "IronNerd", "name": "Matthew McMullan"},
 			{"nick": "Itms", "name": "Nicolas Auvray"},
 			{"nick": "Jaison", "name": "Marco tom Suden"},
 			{"nick": "jammus", "name": "James Scott"},
+			{"nick": "javiergodas", "name": "Javier Godas Vieitez"},
 			{"nick": "Jgwman"},
 			{"nick": "JonBaer", "name": "Jon Baer"},
 			{"nick": "Josh", "name": "Joshua J. Bakita"},
 			{"nick": "jP_wanN", "name": "Jonas Platte"},
 			{"nick": "Jubalbarca", "name": "James Baillie"},
Index: binaries/data/mods/public/gui/summary/summary.js
===================================================================
--- binaries/data/mods/public/gui/summary/summary.js	(revision 18768)
+++ binaries/data/mods/public/gui/summary/summary.js	(working copy)
@@ -3,11 +3,11 @@ const g_MaxHeadingTitle= 8;
 // const for filtering long collective headings
 const g_LongHeadingWidth = 250;
 
 const g_PlayerBoxYSize = 40;
 const g_PlayerBoxGap = 2;
-const g_PlayerBoxAlpha = " 32";
+const g_PlayerBoxAlpha = " 50";
 const g_PlayerColorBoxAlpha = " 255";
 const g_TeamsBoxYStart = 40;
 
 // Colors used for units and buildings
 const g_TrainedColor = '[color="201 255 200"]';
@@ -89,20 +89,20 @@ function updatePanelData(panelInfo)
 		else
 			playerBoxesCounts[playerState.team+1] += 1;
 
 		let positionObject = playerBoxesCounts[playerState.team+1] - 1;
 		let rowPlayer = "playerBox[" + positionObject + "]";
+		let playerOutcome = "playerOutcome[" + positionObject + "]";
 		let playerNameColumn = "playerName[" + positionObject + "]";
-		let playerColorBoxColumn = "playerColorBox[" + positionObject + "]";
 		let playerCivicBoxColumn = "civIcon[" + positionObject + "]";
 		let playerCounterValue = "valueData[" + positionObject + "]";
 
 		if (playerState.team != -1)
 		{
 			rowPlayer = "playerBoxt[" + playerState.team + "][" + positionObject + "]";
+			playerOutcome = "playerOutcomet[" + playerState.team + "][" + positionObject + "]";
 			playerNameColumn = "playerNamet[" + playerState.team + "][" + positionObject + "]";
-			playerColorBoxColumn = "playerColorBoxt[" + playerState.team + "][" + positionObject + "]";
 			playerCivicBoxColumn = "civIcont[" + playerState.team + "][" + positionObject + "]";
 			playerCounterValue = "valueDataTeam[" + playerState.team + "][" + positionObject + "]";
 		}
 
 		let colorString = "color: " +
@@ -116,12 +116,21 @@ function updatePanelData(panelInfo)
 
 		let boxSize = rowPlayerObject.size;
 		boxSize.right = rowPlayerObjectWidth;
 		rowPlayerObject.size = boxSize;
 
-		let playerColorBox = Engine.GetGUIObjectByName(playerColorBoxColumn);
-		playerColorBox.sprite = colorString + g_PlayerColorBoxAlpha;
+		let outcome = Engine.GetGUIObjectByName(playerOutcome);
+		if (playerState.state == "won")
+		{
+			outcome.sprite = "stretched:session/icons/stances/violent.png";
+			outcome.tooltip = translate("Victory");
+		}
+		else if (playerState.state == "defeated")
+		{
+			outcome.sprite = "stretched:session/icons/stances/passive.png";
+			outcome.tooltip = translate("Defeated");
+		}
 
 		Engine.GetGUIObjectByName(playerNameColumn).caption = g_GameData.sim.playerStates[i+1].name;
 
 		let civIcon = Engine.GetGUIObjectByName(playerCivicBoxColumn);
 		civIcon.sprite = "stretched:" + g_CivData[playerState.civ].Emblem;
Index: binaries/data/mods/public/gui/summary/summary.xml
===================================================================
--- binaries/data/mods/public/gui/summary/summary.xml	(revision 18768)
+++ binaries/data/mods/public/gui/summary/summary.xml	(working copy)
@@ -117,13 +117,11 @@
 				<object type="image" name="teamBoxt[i]" size="0 65 100% 100%-50" hidden="true">
 					<object type="text" name="teamNameHeadingt[i]" size="15 5 100% 100%" style="ModernLeftTabLabelText"/>
 					<object size="0 30 100% 100%">
 						<repeat count="8" var="n">
 							<object type="image" name="playerBoxt[i][n]" size="10 0 10 30" hidden="true">
-								<object type="image" sprite="ForegroundBox" size="10 9 34 33">
-									<object name="playerColorBoxt[i][n]" type="image" size="2 2 22 22"/>
-								</object>
+								<object name="playerOutcomet[i][n]" type="image" size="4 8 30 35"/>
 								<object name="playerNamet[i][n]" type="text" size="40 2 208 100%" style="ModernLeftLabelText"/>
 								<object name="civIcont[i][n]" type="image" size="208 5 240 37" />
 								<repeat var="x" count="8">
 									<object name="valueDataTeam[i][n][x]" type="text" style="ModernTabLabelText">
 									</object>
@@ -140,13 +138,11 @@
 			</repeat>
 
 			<object type="image" name="noTeamsBox" size="0 65 100% 100%-50" hidden="true">
 				<repeat count="8">
 					<object type="image" name="playerBox[n]" size="10 0 10 30" hidden="true">
-						<object type="image" sprite="ForegroundBox" size="10 9 34 33">
-							<object name="playerColorBox[n]" type="image" size="2 2 22 22"/>
-						</object>
+						<object name="playerOutcome[n]" type="image" size="4 8 30 35"/>
 						<object name="playerName[n]" type="text" size="40 2 208 100%" style="ModernLeftLabelText"/>
 						<object name="civIcon[n]" type="image" size="208 5 240 37"/>
 						<repeat var="x" count="8">
 							<object name="valueData[n][x]" type="text" style="ModernTabLabelText">
 							</object>